package privacyManager;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.ArrayList;

import org.akogrimo.wp42.contextmanager.entities.Context;

public class AccessPolicy implements Serializable {
	
	private static final long serialVersionUID = 1L;
	private ArrayList listOfGroups = new ArrayList();
	private ArrayList listOfContextType = new ArrayList();
	private ArrayList listOfCurrentContext= new ArrayList();
	private Context context;
	private Matrix matrix=null;
	private DetailLevel level;
	private String userId;
	
	public AccessPolicy(String userId){
		this.userId=userId;
		matrix=new Matrix(this, userId);
		setContextTypeArray();
		writeToFile();	
		
	}
	
	public void setAccessGroupsArray(AccessGroups group){
		
		if(listOfGroups.contains(group)){//ikke eksisterer?
			AccessGroups oldGroup;
			for(int i=0; i<listOfGroups.size();i++){
				oldGroup= (AccessGroups) listOfGroups.get(i);
			       if((oldGroup.getNameGroup()).equals(group.getNameGroup())){
			    	   listOfGroups.remove(oldGroup);
			    	   listOfGroups.add(group);
			    	   System.out.println("Gruppe er lagt til (replace): "+group.getNameGroup());
			       }		    	 
			}
		}
		else{
			listOfGroups.add(group);
			}
		matrix.update(listOfGroups, listOfContextType, listOfCurrentContext);
		writeToFile();
	}
	
	public void removeGroup(AccessGroups group){
		listOfGroups.remove(group);
		matrix.update(listOfGroups, listOfContextType, listOfCurrentContext);
		writeToFile();
	}
	
		
	public void setContextTypeArray(){
				
		int contextType;
		int detailLevel = 0;
		String id; // i kontekst klassen! Hva er dette??
		
		for (int countContext=0; countContext<=3;countContext++){
			id="";
			contextType=countContext+1;
			context=new Context(contextType,id);
			context.setContextType(countContext);
			
			for(int countLevel=0; countLevel<=2;countLevel++){
				detailLevel=countLevel+1;				
				level=new DetailLevel(detailLevel, contextType);
				level.setDetailLevel(countLevel);
				
				SharedContext shareContextType =new SharedContext(contextType,detailLevel);
				listOfContextType.add(shareContextType);
			
			}//for
		}//for
		matrix.update(listOfGroups, listOfContextType, listOfCurrentContext);
		
		writeToFile();
		
	}
	
	public void setCurrentContext(CurrentContext currentContext){
		listOfCurrentContext.add(currentContext);
		matrix.update(listOfGroups, listOfContextType, listOfCurrentContext);
		writeToFile();
	}
	
	public void removeSituation(CurrentContext situation){
		listOfCurrentContext.remove(situation);
		matrix.update(listOfGroups, listOfContextType, listOfCurrentContext);
		writeToFile();
	}
	
	public ArrayList getListOfGroups(){
		return listOfGroups;
			
	}
	
	public ArrayList getListOfTypes(){
		return listOfContextType;
				
	}
	public ArrayList getListOfCurrent(){
		return listOfCurrentContext;
	}
	
	public void writeToFile(){
		
		try {
			File fil =new File("Policy//Access_policy"+userId);
			if(fil.exists())fil.delete();
			FileOutputStream out=new FileOutputStream(fil);
			ObjectOutputStream s = new ObjectOutputStream(out);
			s.writeObject(this);
			s.flush();
			s.close();
			if(out!=null)out.close();
					
		} 
		catch (FileNotFoundException e) {
				e.printStackTrace();
		} catch (IOException e) {
				e.printStackTrace();
		}
	}
	
}
