package privacyManager;

import org.akogrimo.wp42.contextmanager.entities.*;

public class DetailLevelLocation extends DetailLevel{

	private static final long serialVersionUID = 1L;
	private Position positionMin;
	private Position positionMax;
	private Position [] newPositions= new Position[2];
	
	public DetailLevelLocation(int detailLevel) {	
		super(detailLevel, Context.RFID_LOCATION);
	}
		
	public void setRestrictions(int detailLevel, Context c){
		
		RfidContext context = (RfidContext)c;
		float x=context.getPosition().getUtmNorthing();
		float y=context.getPosition().getUtmEasting();
		positionMin= new Position(context.getPosition().getUtmZoneNumber(), context.getPosition().getUtmZoneLetter(),x,y,context.getPosition().getAltitude(), context.getPosition().getAccuracy()) ;
		positionMax=new Position(context.getPosition().getUtmZoneNumber(), context.getPosition().getUtmZoneLetter(),x,y,context.getPosition().getAltitude(), context.getPosition().getAccuracy()) ;
		
		
		float xChange = 0;
		float yChange = 0;
		
		//change values
		if(detailLevel==DetailLevel.LEVEL_TWO){
			xChange=(float) 300.0;	
			yChange=(float) 300.0;	
			
		}
		else if(detailLevel==DetailLevel.LEVEL_THREE){
			xChange=(float) 1000.0;	
			yChange=(float) 1000.0;	
			 
		}
		
		positionMin.setUtmEasting(y-yChange);
		positionMin.setUtmNorthing(x-xChange);
		newPositions[0]=positionMin;
		positionMax.setUtmEasting(y+yChange);
		positionMax.setUtmNorthing(x+xChange);
		newPositions[1]=positionMax;
				
	}
	
	public Object[] getRestrictions(){
			
		return newPositions;
		
	}


}
