package privacyManager;

import java.io.*;
import java.util.*;

public class Matrix implements Serializable {

	private class Index implements Serializable{
		private static final long serialVersionUID = 1L;
		AccessGroups g;
		SharedContext t;
		CurrentContext c;
		
		public Index(AccessGroups g, SharedContext t, CurrentContext c){	
			this.g=g;
			this.t=t;
			this.c=c;
		}
		
	}
		
	private static final long serialVersionUID = 1L;
	private int[][][] elements;
	private ArrayList types;
	private ArrayList groups;
	private ArrayList context;
	private String userId;


	
	//definerer selve matrise strukturen
	public Matrix(AccessPolicy policy, String userId){
		groups=policy.getListOfGroups();
		types=policy.getListOfTypes();
		context=policy.getListOfCurrent();
		this.userId=userId;
		init(groups,types,context);
		writeToFile(userId);
	}	
	/*her ligger logikken for hvordan rettigheter settes. m inkludere de tre klassene som utgjr 
	matrisa og verdiene i listene som returneres derfra*/
	public boolean isValidElement(int g, int t, int c){
		return ((g>-1)&&(g<elements.length)&&(t>-1)&&(t<elements[0].length)&&(c>-1)&&(c<elements[0][0].length));
	}	
	public void setAccessParameters(AccessGroups g, SharedContext t, CurrentContext s, int value){
		
		//finner sharedContext
		int group=0;
		int share=0;
		int situation=0;
		
		for(int i=0; i<types.size();i++){
		SharedContext shareType=(SharedContext)types.get(i);
			if((shareType.getContextType()==t.getContextType())&&(shareType.getDetailLevel()==t.getDetailLevel())){
				share=i;
			}
		}	
			
		for(int i=0 ; i<groups.size();i++){
			AccessGroups gr=(AccessGroups)groups.get(i);
			if((gr.getNameGroup()).equals(g.getNameGroup())){
				group=i;
				}
		}	
		
		for(int i=0 ; i<context.size();i++){
			CurrentContext cc=(CurrentContext)context.get(i);
			if((cc.getName()).equals(s.getName())){
				situation=i;
							
			}
		}	
		
		
		setAccessRights(group,share,situation,value);
			
	}
		
	public void setAccessRights(int g, int t, int c, int value){
		
		if(isValidElement(g,t,c)){	
			elements[g][t][c]=value;
			
		}		
		writeToFile(userId);
	}//metode
	
	public int getAccessParameters(AccessGroups g, SharedContext t, CurrentContext s){
		//finner sharedContext
		int group=0;
		int share=0;
		int situation=0;
		
		for(int i=0; i<types.size();i++){
		SharedContext shareType=(SharedContext)types.get(i);
			if((shareType.getContextType()==t.getContextType())&&(shareType.getDetailLevel()==t.getDetailLevel())){
				share=i;
			}
		}	
			
		for(int i=0 ; i<groups.size();i++){
			AccessGroups gr=(AccessGroups)groups.get(i);
			if((gr.getNameGroup()).equals(g.getNameGroup())){
				group=i;
			}
		}	
		
		for(int i=0 ; i<context.size();i++){
			CurrentContext cc=(CurrentContext)context.get(i);
			if((cc.getName()).equals(s.getName())){
				situation=i;
						
			}
		}	
		int access=getAccessRights(group,share,situation)[0];
			return access;
	}
		

	public int[] getAccessRights(int g, int t, int c){
		
		int[] accessRights = new int[2];
		int accessGranted=0;
		int restrictions = ((SharedContext)types.get(t)).getDetailLevel();
		if(isValidElement(g,t,c))accessGranted=elements[g][t][c];
		accessRights[0]=accessGranted;
		accessRights[1]=restrictions;
		return accessRights;
				
	}
	
		
	public Object[][] status(){
		Object[][] status=new Object[20][20];
		Object[] userList=new Object[10];
		int row=0;
		
		for(int i=0;i<groups.size();i++){
			for(int k=0;k<types.size();k++){
				for(int m=0;m<context.size();m++){
					
					if(isValidElement(i,k,m)){
												
						if(elements[i][k][m]==1){
							
								status[row][0]=new Integer(((SharedContext)types.get(k)).getContextType());
								status[row][1]=new Integer(((SharedContext)types.get(k)).getDetailLevel());
								status[row][2]=(((CurrentContext) context.get(m)).getName());
								status[row][3]=(((AccessGroups)groups.get(i)).getNameGroup());
								for(int u=0;u<((AccessGroups)groups.get(i)).getUserList().size();u++){
								userList[u]=(((AccessGroups)groups.get(i)).getUserList()).entrySet().toArray()[u];
								}
								status[row][4]=userList;
								status[row][5]=new Integer(1);
								System.out.println("ContextType: "+status[row][0]+" Detalj: "+status[row][1]+" Situation: "+status[row][2]+ " Group: "+status[row][3]+" Rights: "+status[row][5]);
								row++;
						}
					}
									
				}//for
			}//for
		}//for*/ 
		
		return status;
		
	}
	
	public void init(ArrayList accessGroups, ArrayList contextType, ArrayList currentContext) {
		this.types=contextType;
		this.groups= accessGroups;
		this.context= currentContext;	
		elements = new int [groups.size()][types.size()][context.size()];
		writeToFile(userId);	
	}
	
	
	
	public void update(ArrayList accessGroups, ArrayList contextType, ArrayList currentContext){
		HashMap access=new HashMap();		
		
		for(int h=0;h<groups.size();h++){
			for(int i=0;i<types.size();i++){
				for(int j=0;j<context.size();j++){
									
					if(isValidElement(h,i,j)){
						if(elements[h][i][j]==1){
						access.put(new Index((AccessGroups)groups.get(h), (SharedContext)types.get(i),(CurrentContext)context.get(j)),new Integer(1));
						
						}
					}
				}
			}	
		}
		
		this.types=contextType;
		this.groups= accessGroups;
		this.context= currentContext;
		elements = new int [accessGroups.size()][contextType.size()][currentContext.size()];	
		for(int h=0;h<accessGroups.size();h++){
			for(int i=0;i<contextType.size();i++){
				for(int j=0;j<currentContext.size();j++){
					if(isValidElement(h,i,j)){
							if(access.containsKey(new Index((AccessGroups)groups.get(h), (SharedContext)types.get(i),(CurrentContext)context.get(j)))){
							setAccessParameters((AccessGroups)groups.get(h), (SharedContext)types.get(i),(CurrentContext)context.get(j),1);
						}
					}
				}
			}	
		}
		
		
		writeToFile(userId);
		
	}
	
	public void writeToFile(String userId){
		
		try {
			File fil =new File("Policy//Access_Matrix"+userId);
			if(fil.exists())fil.delete();
			FileOutputStream out=new FileOutputStream(fil);
			ObjectOutputStream s = new ObjectOutputStream(out);
			s.writeObject(this);
			s.flush();
			s.close();
			if(out!=null)out.close();
					
		} 
		catch (FileNotFoundException e) {
				e.printStackTrace();
		} catch (IOException e) {
				e.printStackTrace();
		}
	}
	

	
}
