package userGui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import org.akogrimo.wp42.contextmanager.entities.Context;
import privacyManager.*;

public class AccessRightsWindow extends JFrame implements ActionListener{
		
	private static final long serialVersionUID = 1L;
	private UserInput input = new UserInput();
    private Privacy privacy= input.getPrivacy();
    private String userId=privacy.getUserID();
	private int sharedContextType = 0;
    private int detailLevel=0;
    private JRadioButton presenceButton;
    private JRadioButton contactButton;
    private JRadioButton locationButton;
    private JRadioButton serviceButton;
    private JRadioButton levelOne;
    private JRadioButton levelTwo;
    private JRadioButton levelThree;
    //private JCheckBox gBox;
    private JComboBox s;
    private JComboBox g;
    private CurrentContext situation=null;
    private AccessGroups group=null;
    private int value=0;
    private Matrix matrix=null;
    private AccessPolicy policy=null;
   
   	public AccessRightsWindow(String windowTitle){
       	super(windowTitle);
       	setSize(500,200);
       	
       policy=privacy.getPolicy(userId);
      	matrix = privacy.getAccessMatrix(userId);
		setAccessRightsComponents();
       	
	}
	
	public void setAccessRightsComponents(){
    	
     	
    	FlowLayout flyt = new FlowLayout(FlowLayout.LEFT);
		Container contentPane = getContentPane();//metode i JFrame, kalles dir
		contentPane.setLayout(flyt);
		
		JLabel typeLabel=new JLabel();
		contentPane.add(typeLabel);
		typeLabel.setText("Context type to share: ");
		
		ActionListener al=new ActionListener(){
	    	public void actionPerformed(ActionEvent e){
	    	   		int i=0; 		
	    	   		
	    		for(i=0;i<=1;i++){
	    		if("Location".equals(e.getActionCommand())){
	    			sharedContextType=Context.RFID_LOCATION;
	    			presenceButton.setSelected(false);
	    			contactButton.setSelected(false);
	    			serviceButton.setSelected(false);
	    		}
	    		else if("Presence".equals(e.getActionCommand())){
	    			sharedContextType=Context.SIP_PRESENCE;
	    			locationButton.setSelected(false);
	    			contactButton.setSelected(false);
	    			serviceButton.setSelected(false);
	    		}
	    		else if("Service".equals(e.getActionCommand())){
	    			sharedContextType=Context.SLP_SERVICE;
	    			presenceButton.setSelected(false);
	    			locationButton.setSelected(false);
	    			contactButton.setSelected(false);
	    		}
	    		else if("Contact".equals(e.getActionCommand())){
	    			sharedContextType=4;
	    			presenceButton.setSelected(false);
	    			locationButton.setSelected(false);
	    			serviceButton.setSelected(false);
	    		}
	    		if("Level 1".equals(e.getActionCommand())){
	    			detailLevel=DetailLevel.LEVEL_ONE;
	    			levelTwo.setSelected(false);
	    			levelThree.setSelected(false);
	    		}
	    		else if("Level 2".equals(e.getActionCommand())){
	    			detailLevel=DetailLevel.LEVEL_TWO;
	    			levelOne.setSelected(false);
	    			levelThree.setSelected(false);
	    		}
	    		else if("Level 3".equals(e.getActionCommand())){
	    			detailLevel=DetailLevel.LEVEL_THREE;
	    			levelOne.setSelected(false);
	    			levelTwo.setSelected(false);
	    		}
	    		}
	    		
		    	}
	    		
		};
	    		
		locationButton= new JRadioButton("Location");
		contentPane.add(locationButton);
		locationButton.addActionListener(al);      
        locationButton.setSelected(false);
		
		presenceButton= new JRadioButton("Presence");
		contentPane.add(presenceButton);
		presenceButton.addActionListener(al);      
        presenceButton.setSelected(false);
        
        serviceButton= new JRadioButton("Service");
		contentPane.add(serviceButton);
		serviceButton.addActionListener(al);      
        serviceButton.setSelected(false);
		
		contactButton= new JRadioButton("Contact");
		contentPane.add(contactButton);
		contactButton.addActionListener(al);      
        contactButton.setSelected(false);
        
   

		JLabel detailLabel=new JLabel();
		contentPane.add(detailLabel);
		detailLabel.setText("Detail level to share: ");
					
		levelOne= new JRadioButton("Level 1");
		contentPane.add(levelOne);
		levelOne.addActionListener(al);
		
		levelTwo= new JRadioButton("Level 2");
		contentPane.add(levelTwo);
		levelTwo.addActionListener(al);      
        levelTwo.setSelected(false);

		levelThree= new JRadioButton("Level 3");
		contentPane.add(levelThree);   
		levelThree.addActionListener(al);      
        levelThree.setSelected(false);

		JLabel currentLabel=new JLabel();
		contentPane.add(currentLabel);
		currentLabel.setText("Choose your current context: ");
		  
		
	    //comboBox of different situations
	    int str= (policy.getListOfCurrent()).size();
	   	CurrentContext[] sit = new CurrentContext[str];
		for(int i=0; i<policy.getListOfCurrent().size();i++){
			CurrentContext situation = (CurrentContext) policy.getListOfCurrent().get(i);
			sit[i]= situation;
			}
		s = new JComboBox(sit);
		contentPane.add(s);
		s.addActionListener(new ActionListener(){
	    	public void actionPerformed(ActionEvent e){
	    		s = (JComboBox)e.getSource();
	            situation= (CurrentContext)s.getSelectedItem();
	    				
	    	}
		});
						
		JLabel groupLabel=new JLabel();
		contentPane.add(groupLabel);
		groupLabel.setText("Choose access group: ");
		
		int size= (policy.getListOfGroups()).size();
		AccessGroups[] groups = new AccessGroups[size];
		for(int i=0; i<policy.getListOfGroups().size();i++){
			AccessGroups group = (AccessGroups) policy.getListOfGroups().get(i);
			groups[i]= group;
			}
		g = new JComboBox(groups);
		contentPane.add(g);
		g.addActionListener(new ActionListener(){
	    	public void actionPerformed(ActionEvent e){
	    		g = (JComboBox)e.getSource();
	            group= (AccessGroups)g.getSelectedItem();
	    				
	    	}
		});
		
		//	check box for grupper: skal kunne velge flere grupper p en gang, men fr ikke henta ut de som er valgt?????
		
//		for(int i=0; i<policy.getAccessGroupsArray().size();i++){
//			AccessGroups group=(AccessGroups) policy.getAccessGroupsArray().get(i);
//			gBox = new JCheckBox(group.getNameGroup());
//		    gBox.setMnemonic(KeyEvent.VK_C); 
//		    gBox.setSelected(false);
//		    contentPane.add(gBox);
//		    gBox.addItemListener(new ItemListener(){
//		    	
//		    	public void itemStateChanged(ItemEvent e) {
//			   
//		    		Object source = e.getItemSelectable();
//
//		    		if (e.getStateChange() == ItemEvent.SELECTED) {
//			    		Object[] o = gBox.getSelectedObjects();
//			    				
//		    		} 
////
//			    	else if (e.getStateChange() == ItemEvent.DESELECTED){
//			       
//			   		}
//		    	}
//	    	});
//	    }
								
		JButton okAccessRights = new JButton("Give Access");
		contentPane.add(okAccessRights);//legger til knappen
	    okAccessRights.addActionListener(this);
    		
		JButton nokAccessRights = new JButton("Remove Access");
		contentPane.add(nokAccessRights);//legger til knappen
	    nokAccessRights.addActionListener(new ActionListener(){
	    	public void actionPerformed(ActionEvent e){
	    		    		
	    		//getting the parameters
	    		SharedContext share = new SharedContext(sharedContextType,detailLevel);
	    		value=0;
	      		matrix.setAccessParameters(group,share,situation, value);	
	      		
	      		dispose();
	    	}
		});
	    
	    
	}
	public void actionPerformed(ActionEvent e) {		
	
		//getting the parameters
		SharedContext share = new SharedContext(sharedContextType,detailLevel);
		value=1;
  		matrix.setAccessParameters(group,share,situation, value);
  		
  		dispose();
	}

}
