package userGui;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.sql.Time;
import java.util.HashMap;

import javax.swing.*;
import org.akogrimo.wp42.contextmanager.entities.Context;
import privacyManager.*;

public class CurrentContextWindow extends JFrame implements ActionListener {
	
	
	private static final long serialVersionUID = 1L;
	private UserInput input = new UserInput();
	private Privacy privacy = input.getPrivacy();
	private String userId=privacy.getUserID();
    private AccessPolicy policy= privacy.getPolicy(userId);
    private JTextField writeSituationName;
  	private HashMap currentContextList= new HashMap();
    private JRadioButton presenceButton;
    private JRadioButton serviceButton;
    private JRadioButton locationButton;
    private int[] values = new int[2];
    private String presence=null;
    private String serviceStatus=null;
    private LocationValues lv=null;
    private PresenceValues pv=null;
    private ServiceValues sv=null;
    private TimeInterval t=null;
    private Time timeStart = null;
   	private Time timeStop = null;
   	private Container contentPane;
   	private boolean setTime=false;

	public CurrentContextWindow(String windowTitle){
		
		super(windowTitle);
       	setSize(500,200);
       	addCurrentContext();
	}
	
	public void addCurrentContext(){
    	    	
    	FlowLayout flyt = new FlowLayout(FlowLayout.LEFT);
		contentPane = getContentPane();
		contentPane.setLayout(flyt);
		
		JLabel currentLabel=new JLabel();
		contentPane.add(currentLabel);
		currentLabel.setText("Name of situation:");
		
		writeSituationName = new JTextField(20);
	    contentPane.add(writeSituationName);
	    
	   	    
	    JLabel currContextLabel=new JLabel();
		contentPane.add(currContextLabel);
		currContextLabel.setText("Chose your current context:");
		
		ActionListener al=new ActionListener(){
	    	public void actionPerformed(ActionEvent e){
	    		
	    		if("Location".equals(e.getActionCommand())){
	    			lv = new LocationValues ("Context values");
		           	lv.setVisible(true);	
		           	
	    		}
	    		else if("Presence".equals(e.getActionCommand())){
	    			pv = new PresenceValues ("Presence status");
		           	pv.setVisible(true);	
		           	
	    			
	    		}
	    		else if("Service information".equals(e.getActionCommand())){
	    			sv=new ServiceValues("Service status");
	    			sv.setVisible(true);
	    			
	    		}
	    	}
	    };
		
		locationButton= new JRadioButton("Location");
		contentPane.add(locationButton);
		locationButton.addActionListener(al);      
        locationButton.setSelected(false);
		
		presenceButton= new JRadioButton("Presence");
		contentPane.add(presenceButton);
		presenceButton.addActionListener(al);      
        presenceButton.setSelected(false);
		
		serviceButton= new JRadioButton("Service information");
		contentPane.add(serviceButton);
		serviceButton.addActionListener(al);      
        serviceButton.setSelected(false);
        
        JButton addTime = new JButton("Set time interval");
		contentPane.add(addTime);
		addTime.addActionListener(new ActionListener(){
	    	public void actionPerformed(ActionEvent e){
	    		setTime=true;
	    		t=new TimeInterval("Contact information");
    			t.setVisible(true);
	    		
	    		
	    	}
		});
		    
	    JButton saveCurrent = new JButton("Save");
		contentPane.add(saveCurrent);
	    saveCurrent.addActionListener(this);  
	    		
    }

		
	public void actionPerformed(ActionEvent e) {
		String situationName = writeSituationName.getText();
		writeSituationName.setText("");
       	if (locationButton.isSelected()==true){
       		values  = lv.getIntegerValues();
       		locationButton.setSelected(false);
       		currentContextList.put(new Integer(Context.RFID_LOCATION), values);
          	}
       	if (presenceButton.isSelected()==true){
       		presence=pv.getStringValues();
       		presenceButton.setSelected(false);
       		currentContextList.put(new Integer(Context.SIP_PRESENCE), presence);
       		
       	}
       	else if (serviceButton.isSelected()==true){
       		serviceStatus=sv.getStringValues();
       		serviceButton.setSelected(false);
       		currentContextList.put(new Integer(Context.SLP_SERVICE), serviceStatus);
       	}
       	
       	if(setTime==true){
       	String tStart=(t.getTimeInterval())[0];
		String tStop=(t.getTimeInterval())[1];
		timeStart=Time.valueOf(tStart);
		timeStop=Time.valueOf(tStop);
       	}
		
		if((timeStart!=null)&&(timeStop!=null)){
			CurrentContext currentContext= new CurrentContext(situationName,currentContextList,timeStart, timeStop);
			policy.setCurrentContext(currentContext);
		}
				
		else{
			
			JTextField timeIsMissing = new JTextField(20);
		    contentPane.add(timeIsMissing);
		    timeIsMissing.setText("You have forgotten to set timeinterval");
		}
		
		values=null;
		timeStart=null;
		timeStop=null;
		presence=null;
		serviceStatus=null;
		
		dispose();
		
	}


}
